function [sys, x0] = led(t,x,u,flag, COLOR, sample)

% function [sys, x0] = led(t,x,u,flag, COLOR, sample)
% S-file to simulate a LED on the block-diagram.
% COLOR is a 3-element vector to specify the LED's color 
% when the input is negative, zero, or positive. The colors
% are specified by numbers from 0..7.
% sample determines the minimum interval between sampling the 
% input.
% Notes: 
% 1. The update is rather slow when the color of the LED is
% changed. Do not use with signals which rapidly change their
% sign, otherwise system performance may seriously suffer.
% 2. In some PC displays some colors may not look like correctly.

% (c) Gy. Simon, 28-07-1997


ns=0;
nd=1;
no=0;
ni=1;

if  abs(flag)==2

	sample_hit = (rem(t+sample/1e8,sample) < sample/1e6);
	if sample_hit 
		if x(1) ~= COLOR(sign(u(1))+2);  % update necessary
			[mysys,myname]=get_param;
			set_param([mysys], 'background', COLOR(sign(u(1))+2));
		end
		sys=COLOR(sign(u(1))+2);
	else
		sys = x;
	end
elseif flag == 3



elseif flag ==4, 
	sys=ceil(t/sample+sample/1e8)*sample;

elseif flag == 0,
	sys=[ns,nd+no,no,ni,0,0]; x0 = zeros(nd+no,1);

elseif flag == 9
	[mysys,myname]=get_param;
	set_param([mysys], 'background', 1); % reset to white

end
