function [sys, x0] = dsfunc(t,x,u,flag,SampTime)

% function [sys, x0] = dsfunc(t,x,u,flag,SampTime)
% S-function to monitor a numerical value on the block
% diagram. SampTime is the minimum interval between
% updates.
% Note: 
% The update is rather slow when the input value changes. 
% To avoid suffer of system performance set higher SampTime
% in case of signals changing continously.

% (c) Gy. Simon, 28-07-1997



sample=SampTime;  % Sample time
ns=0;             % Number of continuous states
nd=1;		  % Number of discrete states
ni=1; no=0;  	  % Number of inputs and outputs. 

if  abs(flag)==2
	sample_hit = (abs(rem(t,sample)) < sample/1e6);
	if sample_hit 
	if u~=x % update only if input changed
		[mysys,myname]=get_param;
		set_param([mysys],...
			'Mask Display',num2str(u));
	end
		sys=u;
	else
		sys = x;
	end
elseif flag == 3

elseif flag ==4, 
	sys=ceil(t/sample+sample/1e8)*sample;

elseif flag == 0,
	sys=[ns,nd+no,no,ni,0,0]; x0 = zeros(nd+no,1);

elseif  abs(flag)==9
	[mysys,myname]=get_param;
	set_param([mysys],...
		'Mask Display','--');

end
